OGRE: Ogre::RTShader::ProgramWriterManager Class Reference - OGRE Documentation

Public Types | Public Member Functions | Static Public Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::RTShader::ProgramWriterManager Class Reference
[RTShader]

`#include <OgreShaderProgramWriterManager.h>`

Inheritance diagram for Ogre::RTShader::ProgramWriterManager:
[legend]

List of all members.

## Public Types
typedef map< String, ProgramWriterFactory * >::type | FactoryMap
## Public Member Functions
| ProgramWriterManager ()
| ~ProgramWriterManager ()
void | addFactory (ProgramWriterFactory *factory)
| Add a new factory object for high-level programs of a given language.
void | removeFactory (ProgramWriterFactory *factory)
| Remove a factory object for high-level programs of a given language.
bool | isLanguageSupported (const String &lang)
| Returns whether a given high-level language is supported.
ProgramWriter * | createProgramWriter (const String &language)
| Create a new, unloaded HighLevelGpuProgram.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static ProgramWriterManager & | getSingleton ()
| Override standard Singleton retrieval.
static ProgramWriterManager * | getSingletonPtr ()
| Override standard Singleton retrieval.
static ProgramWriterManager & | getSingleton (void)
static ProgramWriterManager * | getSingletonPtr (void)
## Protected Attributes
FactoryMap | mFactories
| Factories capable of creating ShaderProgramWriterFactory instances.
## Static Protected Attributes
static ProgramWriterManager * | ms_Singleton

## Detailed Description

Definition at line 59 of file OgreShaderProgramWriterManager.h.

## Member Typedef Documentation

typedef map<String, ProgramWriterFactory*>::type Ogre::RTShader::ProgramWriterManager::FactoryMap

Definition at line 63 of file OgreShaderProgramWriterManager.h.

## Constructor & Destructor Documentation

Ogre::RTShader::ProgramWriterManager::ProgramWriterManager | ( |  | ) |

Ogre::RTShader::ProgramWriterManager::~ProgramWriterManager | ( |  | ) |

## Member Function Documentation

void Ogre::RTShader::ProgramWriterManager::addFactory | ( | ProgramWriterFactory * | factory | ) |

Add a new factory object for high-level programs of a given language.

ProgramWriter* Ogre::RTShader::ProgramWriterManager::createProgramWriter | ( | const String & | language | ) |

Create a new, unloaded HighLevelGpuProgram.

  This method creates a new program of the type specified as the second and third parameters. You will have to call further methods on the returned program in order to define the program fully before you can load it.

Parameters:

  | language | Code of the language to use (e.g. "cg")

static ProgramWriterManager& Ogre::RTShader::ProgramWriterManager::getSingleton | ( |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

static ProgramWriterManager & Ogre::Singleton< ProgramWriterManager >::getSingleton | ( | void |  | ) | `[static, inherited]`

Definition at line 90 of file OgreSingleton.h.

static ProgramWriterManager * Ogre::Singleton< ProgramWriterManager >::getSingletonPtr | ( | void |  | ) | `[static, inherited]`

Definition at line 92 of file OgreSingleton.h.

static ProgramWriterManager* Ogre::RTShader::ProgramWriterManager::getSingletonPtr | ( |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

bool Ogre::RTShader::ProgramWriterManager::isLanguageSupported | ( | const String & | lang | ) |

Returns whether a given high-level language is supported.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

void Ogre::RTShader::ProgramWriterManager::removeFactory | ( | ProgramWriterFactory * | factory | ) |

Remove a factory object for high-level programs of a given language.

## Member Data Documentation

FactoryMap Ogre::RTShader::ProgramWriterManager::mFactories`[protected]`

Factories capable of creating ShaderProgramWriterFactory instances.

Definition at line 66 of file OgreShaderProgramWriterManager.h.

ProgramWriterManager * Ogre::Singleton< ProgramWriterManager >::ms_Singleton`[static, protected, inherited]`

Definition at line 75 of file OgreSingleton.h.

The documentation for this class was generated from the following file:

- OgreShaderProgramWriterManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:25:06